<template>
  <section class="calendar">
    <full-calendar-plugin class="calendar__schedule"
                          defaultView="timeGridWeek"
                          :plugins="calendarPlugins"
                          :locale="ruLocale"
                          :timeZone="timeZone"
                          :header="header"
                          :events="events"
                          :titleFormat="titleFormat"
                          :titleRangeSeparator="titleRangeSeparator"
                          :minTime="minTime"
                          :maxTime="maxTime"
                          :firstDay="firstDay"
                          :editable="editable"
                          :selectable="selectable"
                          :eventOverlap="eventOverlap"
                          :selectOverlap="selectOverlap"
                          :eventDurationEditable="eventDurationEditable"
                          :allDaySlot="allDaySlot"
                          :eventConstraint="eventConstraint"
                          :selectConstraint="selectConstraint"
                          :selectMinDistance="selectMinDistance"
                          :eventRender="eventRender"
                          :datesRender="datesRender"
                          :dayRender="dayRender"
                          @eventDrop="eventDrop"
                          @eventResize="eventResize"
                          @dateClick="dateClick"
                          @select="onSelect"
                          :views="views"
                          :nowIndicator="nowIndicator"
                          :slotDuration="slotDuration"
                          ref="fullCalendar"
    />

    <div class="calendar__legend">
      <span class="calendar__legend-item calendar__legend-item--free">Свободно</span>
      <span class="calendar__legend-item calendar__legend-item--choose">Ваш выбор</span>
      <span class="calendar__legend-item calendar__legend-item--busy">Занято или недоступно</span>
    </div>
  </section>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex';

  import FullCalendar from '@fullcalendar/vue'
  import timeGridPlugin  from '@fullcalendar/timegrid';
  import interaction  from '@fullcalendar/interaction';
  import ruLocale from '@fullcalendar/core/locales/ru';

  import { getFloatTime, getStringTime } from '../assets/js/helpers/formatTime';
  import { timeZoneOffsets } from '../assets/js/helpers/consts';

  export default {
    components: {
      'full-calendar-plugin': FullCalendar
    },
    props: {
      bookings: {
        type: Array,
        required: true,
      },

      noOwnBookings: {
        type: Array,
        required: true
      },

      chosenItems: {
        type: Array,
        required: true,
      },

      minMaxTimes: {
        type: Object,
        required: true
      },

      changeStep: {
        type: String,
        default: '01:00:00'
      },

      minDuration: {
        type: String,
        default: '01:00:00'
      },

      roomId: {
        type: [Number, String],
        required: true
      },

      timezone: {
        type: String,
        default: 'Europe/Moscow'
      },

      schedule: {
        type: Array,
        required: true
      },

      getNoWorkingHours: {
        type: Function,
        required: true
      },

      selectWithVisitors: {
        type: Function,
        required: true
      }
    },
    data: () => ({
      calendarPlugins: [ timeGridPlugin, interaction  ],
      ruLocale: ruLocale,
      timeZone: 'Europe/Moscow',
      header: {
        left: '',
        center: '',
        right: 'title next'
      },
      titleFormat: { year: 'numeric', month: 'long', day: 'numeric' },
      titleRangeSeparator: '-',
      views: {
        timeGridThree: {
          type: 'timeGrid',
          duration: { days: 3 }
        }
      },
      minTime: '00:00:00',
      maxTime: '24:00:00',
      firstDay: 1,
      editable: false,
      eventOverlap: false,
      eventDurationEditable: false,
      allDaySlot: false,
      selectable: true,
      selectOverlap: false,
      eventConstraint: {
        startTime: '9:00',
        endTime: '22:00',
      },
      selectConstraint: {
        startTime: '9:00',
        endTime: '22:00',
      },
      selectMinDistance: 50,
      slotDuration: '00:30:00',
      nowIndicator: true,
      handleWindowResize: true,
      eventRender: (event) => {
        event.el.insertAdjacentHTML(
          `beforeend`,
          `<span class="remove-event-btn js-remove-event" data-id="${event.event.id}"></span>`);

        const timeEl = event.el.querySelector('.fc-time-grid-event .fc-time');

        if (timeEl.dataset.full.length < 5 && timeEl.dataset.full === '0:00') {
          timeEl.querySelector('span').insertAdjacentHTML('beforeend', ' - 0:00')
        }
      },
      dayRender: function () {},
      eventDrop: function () {},
      eventResize: function () {},
      datesRender: function () {},
      dateClick: function() {},
      onSelect: function() {},
      events: [],
      calendarApi: null,
    }),

    beforeMount() {
      document.querySelector('body')
        .insertAdjacentHTML('beforeBegin', `<style>
            .calendar__schedule .fc-body .fc-time-grid .fc-bg .fc-day .calendar__col { background-size: 2rem calc(100% / ${this.hoursCount}); }
            ${this.timeIntervalsHalf.length % 2 === 1 ? `.calendar__schedule .fc-body .fc-time-grid .fc-bg .fc-day .calendar__col .calendar__slot-price:last-child { flex: 1 1; }` : ''}
            ${getFloatTime(this.minMaxTimes.startTime) % 1 === .5 ? `.calendar__schedule .fc-body .fc-axis.fc-time span::after { content: ''; }` : ''}
        </style>`)
    },

    mounted() {
      this.calendarApi = this.$refs.fullCalendar.getApi();
      this.changeCalendarView();

      // изменяем ограничение времени
      this.minTime = this.minMaxTimes.startTime;
      this.maxTime = this.minMaxTimes.endTime;
      this.eventConstraint = this.minMaxTimes;
      this.selectConstraint = this.minMaxTimes;

      this.timeZone = this.timezone;

      this.finishRenderCalendar();
      this.datesRender = this.finishRenderCalendar;
      this.dayRender = this.onDayRender;
      this.dateClick = this.addCalendarEvent;
      this.onSelect = this.onSelectDate;
      this.eventDrop = this.changeEvent;
      this.eventResize = this.changeEvent;

      // Обработчик клика на кнопку х на карточке бронирования в календаре
      this.$el.addEventListener('click', (e) => {
        const target = e.target;

        if (!target.classList.contains('js-remove-event')) return;

        this.removeBooking({ roomId: this.roomId, bookingId: target.dataset.id })
      });

      this.setSelectMinDistance();

      window.addEventListener('resize', () => this.setSelectMinDistance());
    },
    computed: {
      ...mapGetters({
        isAuthenticated: 'auth/isAuthenticated'
      }),

      isMobile() {
        return this.$store.state.isMobile;
      },

      minInterval() {
        let result = 0;
        const minDuration = getFloatTime(this.minDuration);

        result = Math.ceil(minDuration);

        return result;
      },

      hoursCount() {
        return getFloatTime(this.minMaxTimes.endTime) - getFloatTime(this.minMaxTimes.startTime)
      },

      timeIntervalsHalf() {
        const result = [];
        let tmpTime = getFloatTime(this.minMaxTimes.startTime);
        const endTime = getFloatTime(this.minMaxTimes.endTime);

        for (tmpTime; tmpTime < endTime; tmpTime += .5) {
          result.push({ from: tmpTime, to: tmpTime + .5 })
        }

        return result
      }

    },
    watch: {
      isMobile() {
        this.changeCalendarView();
      },

      bookings() {
        this.events = [
          ...this.noOwnBookings.map((booking) => this.formatEvents(booking)),
          ...this.chosenItems.map((chosenItem) => this.formatEvents(chosenItem))
        ];
      },

      chosenItems() {
        this.events = [
          ...this.noOwnBookings.map((booking) => this.formatEvents(booking)),
          ...this.chosenItems.map((chosenItem) => this.formatEvents(chosenItem))
        ];
      }
    },
    methods: {
      ...mapActions({
        addBooking: 'schedule/addBooking',
        removeBooking: 'schedule/removeBooking',
        editBooking: 'schedule/editBooking'
      }),

      setSelectMinDistance() {
        const globalFZ = parseFloat(window.getComputedStyle(document.querySelector('html')).fontSize);

        this.selectMinDistance = 1.125 * globalFZ * (getFloatTime(this.minDuration) / 0.5);
      },

      onDayRender(dayRenderInfo) {
        const timeZoneOffset = timeZoneOffsets[this.timezone].float;
        const currentTime = getFloatTime(new Date().toISOString().substr(11, 5)) + timeZoneOffset;

        const nowDate = new Date();
        const isToday = nowDate.getFullYear() === dayRenderInfo.date.getFullYear()
          && nowDate.getMonth() === dayRenderInfo.date.getMonth()
          && nowDate.getDate() === dayRenderInfo.date.getDate();

        let tmpPriceFirst = null;
        let tmpPriceSecond = null;

        dayRenderInfo.el.insertAdjacentHTML(`beforeend`, `<div class="calendar__col">

          ${this.timeIntervalsHalf.map((timeObj, index) => {
            let neededScheduleItem = this.getNeededScheduleItem(timeObj, dayRenderInfo.date);
            let tmpMarkup = '';

            if (neededScheduleItem && !(isToday && currentTime >= timeObj.from)) {
              tmpPriceFirst = neededScheduleItem.price;
              tmpMarkup = `<span class="">${neededScheduleItem.rules.visitors !== null ? 'от ' : ''}${ neededScheduleItem.price } ₽</span>`;
            } else {
              tmpPriceFirst = 0;
              tmpMarkup = `<span class="">x</span>`;
            }

            if (index % 2 === 0) {
              tmpPriceSecond = tmpPriceFirst;
              return `<div class="calendar__slot-price">${tmpMarkup}`
            } else {
              if (tmpPriceSecond === tmpPriceFirst) return `</div>`;

              tmpPriceSecond = tmpPriceFirst;
              return `${tmpMarkup}</div>`
            }

          }).join('')}
        </div>`)
      },

      getNeededScheduleItem(timeObj, calendarDate) {
        let neededScheduleItem = null;
        const nowDate = new Date();
        const calendarDayIndex = calendarDate.getDay() || 7;
        const nowDateWithoutTime = new Date(nowDate.toISOString().substr(0, 10));
        const calendarDateWithoutTime = new Date(calendarDate.toISOString().substr(0, 10));

        this.schedule.forEach((scheduleItem) => {
          if (timeObj.from >= getFloatTime(scheduleItem.rules.from)
            && timeObj.to <= (getFloatTime(scheduleItem.rules.to) || 24)) {

            if (scheduleItem.rules.weekdays.includes(calendarDayIndex)
              && (Number(calendarDateWithoutTime) >= Number(nowDateWithoutTime))) {
              neededScheduleItem = !neededScheduleItem ? scheduleItem : neededScheduleItem.price < scheduleItem.price ? neededScheduleItem : scheduleItem;
            }
          }
        });

        return neededScheduleItem;
      },

      checkNoWorkingHours(startTime, endTime, date) {
        const noWorkingIntervals = this.getNoWorkingHours(date);
        let hasNoWorkingHours = false;

        noWorkingIntervals.forEach((interval) => {
          if (interval.from === startTime || interval.to === endTime
            || startTime > interval.from && startTime < interval.to
            || endTime > interval.from && endTime < interval.to
            || startTime < interval.from && endTime > interval.to
          ) hasNoWorkingHours = true;
        });

        return hasNoWorkingHours
      },

      changeCalendarView() {
        if (this.isMobile) {
          this.calendarApi.changeView('timeGridThree')
        } else {
          this.calendarApi.changeView('timeGridWeek')
        }
      },

      formatEvents(booking) {
        if (booking.owner) {

          if (booking.ordered) {
            booking.title = 'Заказано';
            booking.className = 'selected-date selected-date--ordered';
          } else {
            booking.title = 'Выбрано';
            booking.durationEditable = true;
            booking.editable = true;
            booking.className = 'selected-date';
          }

        } else {

          booking.title = 'Занято';
          booking.className = 'busy-date';

        }

        return booking;
      },

      addCalendarEvent(info) {
        const startTime = getFloatTime(info.dateStr.substr(11, 5));
        const endTime = startTime + this.minInterval;
        const date = info.date - (timeZoneOffsets[this.timezone].float * 60 * 60 * 1000);
        const hasNoWorkingHours = this.checkNoWorkingHours(startTime, endTime, new Date(date));
        const visitors = this.selectWithVisitors(startTime, endTime, date, {index: 0});

        if (hasNoWorkingHours) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Интервал содержит нерабочие часы офиса',
          });

          return;
        }

        this.addEvent(new Date(date), startTime, endTime, visitors);
      },

      onSelectDate(info) {
        const startTime = getFloatTime(info.startStr.substr(11, 5));
        const endTime = getFloatTime(info.endStr.substr(11, 5)) || 24;
        const startDate = info.start - (timeZoneOffsets[this.timezone].float * 60 * 60 * 1000);
        const hasNoWorkingHours = this.checkNoWorkingHours(startTime, endTime, new Date(startDate));
        const visitors = this.selectWithVisitors(startTime, endTime, startDate, {index: 0});

        if (hasNoWorkingHours) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Интервал содержит нерабочие часы офиса',
          });

          this.calendarApi.unselect();
          return;
        }

        // Проверка на кратность размеру слота бронирования
        if ((endTime - startTime) % getFloatTime(this.changeStep) !== 0) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: `Интервал не кратен размеру слота бронирования: ${this.changeStep}`,
          });

          this.calendarApi.unselect();
          return;
        }

        if (endTime - startTime <= this.minInterval) {
          this.calendarApi.unselect();
          return;
        }

        this.addEvent(new Date(startDate), startTime, endTime, visitors);
      },

      addEvent(date, start, end, visitors) {
        this.calendarApi.unselect();

        if (!this.isAuthenticated) {
          this.$router.push({ path: `/login`, query: { place: this.roomId } });

          return;
        }

        this.addBooking({
          roomId: this.roomId,
          booking: {
            date,
            timeFrom: {
              label: getStringTime(start),
              value: start
            },
            timeTo: {
              label: getStringTime(end),
              value: end,
            },
            visitors
          }
        });
      },

      changeEvent(info) {
        const currentDate = new Date();

        if ((info.event.end - info.event.start) / 3600000 < this.minInterval) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Интервал меньше минимального слота бронирования',
          });

          info.revert();
          return
        }

        // Проверка на бронирование прошлого
        const stringStartTime = info.event.start.toISOString().substr(11, 5);
        const floatStartTime = getFloatTime(stringStartTime);
        const stringEndTime = info.event.end.toISOString().substr(11, 5);
        const floatEndTime = getFloatTime(stringEndTime);

        const prewStringStartTime = info.prevEvent ? info.prevEvent.start.toISOString().substr(11, 5) : info.oldEvent.start.toISOString().substr(11, 5);
        const prewFloatStartTime = getFloatTime(prewStringStartTime)
        const prewStringEndTime = info.prevEvent ? info.prevEvent.end.toISOString().substr(11, 5) : info.oldEvent.end.toISOString().substr(11, 5);
        const prewFloatEndTime = getFloatTime(prewStringEndTime)
        const date = info.event.start - (timeZoneOffsets[this.timezone].float * 60 * 60 * 1000);

        const visitors = this.selectWithVisitors(floatStartTime, floatEndTime, date) !== null ? this.getVisitorsThisBooking(prewFloatStartTime, prewFloatEndTime) || this.selectWithVisitors(floatStartTime, floatEndTime, date, {index: 0}) : null
        const isoTimeStart = info.event.start.setHours(stringStartTime.match(/\d+/g)[0], stringStartTime.match(/\d+/g)[1]);

        if (isoTimeStart < currentDate) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Нельзя бронировать прошедшее время',
          });

          info.revert();
          return
        }

        // Проверка на отсутствие в бронировании нерабочих часов
        const hasNoWorkingHours = this.checkNoWorkingHours(floatStartTime, floatEndTime,  info.event.start);

        if (hasNoWorkingHours) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Интервал содержит нерабочие часы офиса',
          });

          info.revert();
          return;
        }

        // Проверка на кратность размеру слота бронирования
        if ((floatEndTime - floatStartTime) % getFloatTime(this.changeStep) !== 0) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: `Интервал не кратен размеру слота бронирования: ${this.changeStep}`,
          });

          info.revert();
          return;
        }

        this.editBooking({
          roomId: this.roomId,
          bookingId: info.event.id,
          bookingInfo: {
            date: new Date(date),
            timeFrom: {
              label: stringStartTime,
              value: floatStartTime
            },
            timeTo: {
              label: stringEndTime,
              value: floatEndTime
            },
            visitors
          }
        });
      },

      getVisitorsThisBooking(timeFrom, timeTo) {
        const currentBookingsInRoom = this.$store.state.schedule.bookings.find((booking) => booking.roomId === this.roomId)
        let thisVisitors = null

        currentBookingsInRoom.bookingItems.forEach((booking) => {
          if (timeFrom == booking.timeFrom.value && timeTo == booking.timeTo.value) {
            thisVisitors = booking.visitors
          }
        })

        return thisVisitors
      },

      finishRenderCalendar(calendar) {
        if (calendar) {
          if (calendar.view.currentStart < new Date()) {
            this.header.right = 'title next'
          } else {
            this.header.right = 'title prev,next'
          }
        }

        this.$nextTick(() => {
          this.$el.querySelector('.calendar__schedule .fc-body .fc-scroller .fc-content-skeleton .fc-axis')
            .setAttribute('aria-label', getFloatTime(this.minMaxTimes.endTime) === 24 ? '00:00' : this.minMaxTimes.endTime);
        });
      }
    }
  }
</script>

<style lang="scss">
  @import '@fullcalendar/core/main.css';
  @import '@fullcalendar/timegrid/main.css';

  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .calendar {
    .remove-event-btn {
      position: absolute;
      z-index: 3;
      top: rem(2);
      right: rem(2);

      display: block;
      width: rem(26);
      height: rem(26);
      padding: rem(8);

      box-sizing: border-box;
      background: url('/images/icon-cross.svg') center no-repeat;
      background-size: rem(10) rem(10);
      cursor: pointer;
    }

    &__legend {
      display: flex;
      align-items: center;

      margin-top: rem(40);

      @media (max-width: $mobile-width) {
        flex-flow: wrap;

        margin: rem(16) rem(-8) rem(-8) rem(42);
      }
    }

    &__legend-item {
      & + & {
        margin-left: rem(40);

        @media (max-width: $mobile-width) {
          margin-left: rem(8);
        }
      }

      display: flex;
      align-items: center;

      font-size: rem(12);
      line-height: rem(16);
      color: rgba($black, .6);
      white-space: nowrap;

      @media (max-width: $mobile-width) {
        margin: rem(8);
      }

      &::before {
        content: '';

        width: rem(40);
        height: rem(16);
        margin-right: rem(12);

        border-radius: rem(4);
      }

      &--free::before {
        background: $light-gray;
        border: rem(1) solid rgba($white, 0.4);
        box-shadow: inset rem(-4) rem(-4) rem(2) rgba($white, 0.6),
        inset rem(4) rem(4) rem(6) #D5DCE4,
        inset rem(-4) rem(-4) rem(4) rgba($white, 0.25);
      }

      &--choose::before {
        background: $gradient-green;
        border: rem(1) solid rgba($white, 0.3);
      }

      &--busy::before {
        @include gray-btn;

        background: #EAEEF3;
      }
    }


    &__schedule {
      margin-left: rem(-50);

      @media (max-width: $mobile-width) {
        margin-left: 0;
      }

      .fc-header-toolbar{
        margin-bottom: rem(30);
        padding-left: rem(50);

        .fc-left {
          &::before {
            content: 'Выберите дату и время бронирования';

            @include p2;

            @media (max-width: $mobile-width) {
              display: none;
              content: none;
            }
          }
        }

        .fc-right {
          display: flex;
          align-items: center;

          h2 {
            @include p2;

            margin-right: rem(24);
            color: $black;
          }

          .fc-button {
            @include gray-btn;

            & + .fc-button {
              margin-left: rem(10);
            }

            display: flex;
            align-items: center;
            justify-content: center;

            width: rem(40);
            height: rem(40);
            padding: 0;

            border-radius: 50%;

            &:active {
              @include gray-btn-active;
            }

            &:hover {
              .fc-icon::before {
                color: $black;
              }
            }

            .fc-icon {
              font-size: 1.375rem;

              &::before {
                color: #BDC5D8;
              }
            }
          }
        }
      }

      .fc-head {
        .fc-row.fc-widget-header {
          margin-bottom: rem(12);
        }

        .fc-widget-header {
          border: none!important;
          margin-right: 0!important;

          span {
            @include p3;
            color: rgba($black, .6);
            text-transform: capitalize;
          }

          &.fc-today {
            span {
              @include gray-btn;

              box-sizing: border-box;

              height: rem(26);
              padding: 0 rem(12);
              display: inline-flex;
              align-items: center;

              border-radius: rem(40);
              color: $black;
            }
          }
        }

        table {
          border: none;

          .fc-axis {
            border: none;
          }

          .fc-day-header {
            border: none;
            vertical-align: middle;
            box-sizing: border-box;

            height: rem(26);
          }
        }
      }

      .fc-axis {
        width: rem(50) !important;
        padding-right: rem(12);
        box-sizing: border-box;
      }

      .fc-body {

        .fc-widget-content {
          height: 100%;
          border: none;
        }

        .fc-scroller {
          overflow: initial!important;
          height: auto !important;

          .fc-content-skeleton {
            height: 100%;

            & > table {
              height: 100%;
            }

            .fc-axis {
              &::after {
                @include p3;

                content: attr(aria-label);
                position: absolute;
                right: rem(12);
                bottom: rem(-6);

                line-height: rem(16);
                color: rgba($black, .6);
              }
            }
          }
        }

        .fc-axis.fc-time {

          span {
            @include p3;

            position: absolute;
            top: rem(-10);
            right: rem(12);

            display: inline-flex;

            line-height: rem(16);
            color: rgba($black, .6);

            &::after {
              content: ':00'
            }
          }
        }

        .fc-divider.fc-widget-header {
          display: none;
        }

        .fc-time-grid .fc-slats td {
          height: rem(18);
        }

        .fc-time-grid .fc-slats .fc-minor td {
          border: none;
        }

        .fc-day.fc-widget-content.fc-today {
          background: transparent;
        }

        .fc-content-skeleton td {
          height: 100%;
          border: none;
        }

        .fc-time-grid .fc-bg .fc-day .calendar__col {
          display: flex;
          flex-flow: column;
          align-items: center;

          width: calc(100% - .375rem);
          height: calc(100%);
          margin-left: rem(3);

          background: linear-gradient($gray 97%, #DCE2EF 0);
          box-shadow: inset rem(-4) rem(-4) rem(2) rgba($white, 0.6),
            inset rem(4) rem(4) rem(6) #D5DCE4,
            inset rem(-4) rem(-4) rem(4) rgba($white, 0.25);
          border-radius: rem(8);

          .calendar__slot-price {
            flex: 2 2;

            display: flex;
            flex-flow: column;
            align-items: center;
            justify-content: center;

            span {
              font-size: rem(12);
              line-height: rem(15);
              color: $dark-gray;
            }
          }
        }

        .fc-content-col {
          box-sizing: border-box;

          width: calc(100% - .375rem);
          height: 100%;
          padding: 0 rem(4);
          margin-left: rem(3);

          .selected-date {
            display: flex;
            align-items: center;
            justify-content: center;
            margin: rem(2) 0;

            background: $gradient-green;
            border: rem(1) solid rgba($white, 0.3);
            box-sizing: border-box;
            border-radius: rem(8);

            &:first-child {
              margin-top: rem(4);
            }

            &:last-child {
              margin-bottom: rem(4);
            }

            &--ordered {
              opacity: .4;

              .remove-event-btn {
                display: none;
              }
            }

            .fc-content {
              display: flex;
              flex-flow: column;
              align-items: center;

              .fc-time {
                order: 2;

                font-weight: 600;
                font-size: rem(14);
                color: $white;
              }

              .fc-title {
                font-size: rem(12);
                color: rgba($white, .6);

                margin-bottom: rem(4);
              }
            }
          }

          .busy-date {
            display: flex;
            align-items: center;
            justify-content: center;
            margin: rem(2) 0;

            &:first-child {
              margin-top: rem(4);
            }

            &:last-child {
              margin-bottom: rem(4);
            }

            font-size: rem(12);
            color: rgba($dark-gray, .7);

            background: #EAEEF3;
            border: rem(1) solid rgba($white, 0.4);
            box-sizing: border-box;
            box-shadow: 0 0 rem(6) #D5DCE4;
            border-radius: rem(8);

            .remove-event-btn {
              display: none;
            }

            .fc-time {
              display: none;
            }
          }
        }

        .fc-time-grid .fc-now-indicator-arrow {
          display: none;
        }

        .fc-time-grid .fc-now-indicator-line {
          left: rem(-3);
          width: calc(100% + 0.1875rem);
          height: rem(2);

          background: #7CE1D4;
          border-radius: 25%;
          border: none;
        }
      }

      // стили для перетаскиваемого события
      .fc-event.fc-dragging {
        display: flex;
        align-items: center;
        justify-content: center;

        background: $gradient-green;
        border: rem(1) solid rgba($white, 0.3);
        box-sizing: border-box;
        border-radius: rem(8);

        .fc-content {
          display: flex;
          flex-flow: column;
          align-items: center;

          .fc-time {
            order: 2;

            font-weight: 600;
            font-size: rem(14);
            color: $white;
          }

          .fc-title {
            font-size: rem(12);
            color: rgba($white, .6);

            margin-bottom: rem(4);
          }
        }
      }
    }
  }

</style>

